//=============================================================================
// Microcontroller Serial Ʈ  API Լ
// by jh.park(gudo@naver.com)
// [serial.c]
//=============================================================================

/*
 - [2007.01.02] 
 -  Ŀ    ִ APIԼ  Ʈ
  - ø Ʈ APIԼ 
  - _UART0_ENABLE UART0

 - [2007.03.25]   
  - U0_Init()Լ Ʈ ʱȭ U0_SetBaud(BAUD_57600) 
   -> Ʈ  ʵǴ  
   
 - [2007.04.01]
  - serial.h -> serial.c  serial_hal.h hal    ֵ
  - (serial_hal.h) ߰ system.h HAL    ֵ ϰ...
  -  halmegxx.h  _HAL_MEGA128_UART, _HAL_MEGA8_UART ̿Ͽ HAL
*/

#include "..\00_hal\serial_hal.h"

//------------------------------------------------------------------------------
// UART Defination
//------------------------------------------------------------------------------
#define BAUD_9600							0
#define BAUD_14400							1
#define BAUD_19200							2
#define BAUD_28800							3
#define BAUD_38400							4		
#define BAUD_57600							5		
#define BAUD_76800							6		
#define BAUD_115200							7	


#ifdef _UART0_ENABLE
//-----------------------------------------------------------------------------
// USART Fuction Declaration
UINT U0_IsGetByte(void);
void U0_Init(UINT Baud);
void U0_SetBaud(unsigned char baud);
unsigned char U0_GetByte(void);
void U0_PutByte(unsigned char Data);
void U0_PutBuf(unsigned char *str, unsigned char len);
//------------------------------------------------------------------------------

//------------------------------------------------------------------------------
// Serial Prot0 Utility Fuction Routine
void U0_Init(UINT Baud)
{
	U0_SetBaud(Baud);
	
	u0_hal_init();
}

void U0_SetBaud(unsigned char baud)
{
	u0_baudrate(baud);
}

unsigned char U0_GetByte(void)
{
	u0_WaitForReceive();
	
	return u0_RxData();
}

void U0_PutByte(unsigned char Data)
{
	u0_WaitForSend();
	
	u0_TxData(Data);
}

void U0_PutBuf(unsigned char *str, unsigned char len)
{
	unsigned char i =0;
	
    for(i=0;i<len;i++)
    {
        U0_PutByte(*(str+i));
    }
}

void U0_PutStr(unsigned char *str)
{
    while(*str != 0)
    {
        U0_PutByte(*str);
        str++;
    }
}

UINT U0_IsGetByte(void)
{
	return u0_IsReceiveData();
}

//------------------------------------------------------------------------------
#endif	//end UART0 ENABLE


#ifdef _UART1_ENABLE
//-----------------------------------------------------------------------------
// USART Fuction Declaration
unsigned char U1_IsReceiveData(void);
void U1_Init(void);
//void U1_SetBaud(unsigned char baud);
unsigned char U1_GetByte(void);
void U1_PutByte(unsigned char Data);
void U1_PutStr(unsigned char *str);
void U1_PutBuf(unsigned char *str, unsigned char len);
//------------------------------------------------------------------------------

//------------------------------------------------------------------------------
// Serial Prot1 Utility Fuction Routine
void U1_Init(void)
{
//	U0_SetBaud(BAUD_57600);
	
	u1_hal_init();
}

void U1_SetBaud(unsigned char baud)
{
	u1_baudrate(baud);
}

unsigned char U1_GetByte(void)
{
	u1_WaitForReceive();
	
	return u1_RxData();
}

void U1_PutByte(unsigned char Data)
{
	u1_WaitForSend();
	
	u1_TxData(Data);
}

void U1_PutBuf(unsigned char *str, unsigned char len)
{
	unsigned char i =0;
	
    for(i=0;i<len;i++)
    {
        U1_PutByte(*(str+i));
    }
}

void U1_PutStr(unsigned char *str)
{
    while(*str != 0)
    {
        U1_PutByte(*str);
        str++;
    }
}

unsigned char U1_IsReceiveData(void)
{
	return u1_IsReceiveData();
}
//------------------------------------------------------------------------------
#endif	//end _UART1_ENABLE
